#include <stdio.h> 
#include <stdlib.h> 
#include <pthread.h> 
#include <stdbool.h>

#define N 100000

int x[2 * N];
int n;

int odomknute = 1;

int vyber_zamykacie() {
	while (odomknute != 1);
	odomknute = 0;
	int res = x[n];
	n++;
	odomknute = 1;
	return res;
}

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

int vyber_semafor() {
	pthread_mutex_lock(&mutex);
	int res = x[n];
	n++;
	pthread_mutex_unlock(&mutex);
	return res;
}

int vyber() {
	int res = x[n];
	n++;
	return res;
}

void *MojThread(void *vargp) {
	int *li = (int *)vargp;
	for (int i = 0; i < N; i++) {
		li[i] = vyber(); // <<< zmenou tohto riadku sa daju skusat jednotlive verzie funkcie vyber
	}
	return NULL;
}

int li1[N];
int li2[N];

bool testuj(int li1[], int li2[], int n) {
	int i1, i2, narade;
	i1 = 0; i2 = 0; narade = 0;
	FILE *f;
	f = fopen("test.txt", "w");
	bool ok = true;

	if (n != 2 * N) {
		fprintf(f, "nespravne n: %d\n", n); ok = false;
	}

	while (narade < 2 * N) {
		if (i1 < N && li1[i1] == narade)
			i1++;
		else if (i2 < N && li2[i2] == narade)
			i2++;
		else {
			fprintf(f, "chyba: %d\n", narade); ok = false;
		}

		while (i1 < N && li1[i1] == narade) {
			i1++; fprintf(f, "dvakrat: %d\n", narade); ok = false;
		}
		while (i2 < N && li2[i2] == narade) {
			i2++; fprintf(f, "dvakrat: %d\n", narade); ok = false;
		}
		narade++;
	}

	fclose(f);
	return ok;
}

int main() {
    pthread_t h[2]; 
    
	for (int i = 0; i < 2 * N; i++)
		x[i] = i;
	n = 0;

    pthread_create(&h[0], NULL, MojThread, &li1); 
    pthread_create(&h[1], NULL, MojThread, &li2); 

    for (int i = 0; i < 2; i++)
    	pthread_join(h[i], NULL); 
    	
	printf("--koniec\n");

	if (testuj(li1, li2, n))
		printf("OK\n");
	else
		printf("ZLE\n");

	return 0;
}
